$(document).ready(function() {
    $('.carousel').slick({
      slidesToShow: 3.5,
      slidesToScroll: 1,
      infinite: false,
      arrows: true,
      dots: false,
      centerMode: true,
      initialSlide: 1,
      variableWidth: false,
      draggable: false,
      prevArrow: '<button type="button" class="slick-prev"><i class="fas fa-chevron-left"></i></button>',
      nextArrow: '<button type="button" class="slick-next"><i class="fas fa-chevron-right"></i></button>',
      responsive: [
        {
          breakpoint: 768,
          settings: {
            slidesToShow: 2.5,
            slidesToScroll: 1,
          }
        },
        {
          breakpoint: 572,
          settings: {
            slidesToShow: 1,
            slidesToScroll: 1,
          }
        },
      ]
    });

    $('.slick-prev').hide();

    $('.carousel').on('afterChange', function(event, slick, currentSlide){
      if (currentSlide === 0) {
        $('.slick-prev').hide();
      } else {
        $('.slick-prev').show();
      }

      if (currentSlide >= slick.slideCount - 3) {
        $('.slick-next').hide();
      } else {
        $('.slick-next').show();
      }
    });
});


// Register the ScrollTrigger plugin
gsap.registerPlugin(ScrollTrigger);

// Load the Lottie animation
var anim = lottie.loadAnimation({
  container: document.getElementById('wrench-animation-wrapper'), // the dom element that will contain the animation
  renderer: 'svg',
  loop: false,
  autoplay: false,
  path: 'https://static.igem.wiki/teams/5237/homepagestuffs/wrenchbig.json' // Replace with the path to your Lottie JSON file
});

// Wait for the animation data to be load+
anim.addEventListener('DOMLoaded', function() {
  var totalFrames = anim.totalFrames;

  // Create a GSAP tween to control the Lottie animation
  gsap.to({frame: 0}, {
    frame: totalFrames - 1,
    ease: "none",
    scrollTrigger: {
      trigger: "#wrench-animation-wrapper",
      start: "top 40%",
      end: "bottom 20%",
      scrub: 2,
      markers: false,
    },
    onUpdate: function() {
      anim.goToAndStop(Math.round(this.targets()[0].frame), true);
    }
  });
});

// Wait for the Lottie animation to be ready
// Register GSAP plugins
gsap.registerPlugin(ScrollTrigger);

// Load the Lottie animation
var lottieAnimation = lottie.loadAnimation({
  container: document.getElementById('toolbox-animation-wrapper'), // The DOM element to render the animation
  renderer: 'svg',
  loop: false,
  autoplay: false,
  path: 'https://static.igem.wiki/teams/5237/homepagestuffs/toolboxbig-v2home.json', // Path to the animation JSON
});

// Wait for the Lottie animation to be fully loaded
lottieAnimation.addEventListener('DOMLoaded', function () {
  const totalFrames = lottieAnimation.totalFrames;

  // Create the GSAP timeline
  const tl = gsap.timeline({
    scrollTrigger: {
      trigger: '.fourth-block',
      start: 'top top',
      end: '+=300%', // Adjust the scroll length
      pin: true,
      scrub: 2,
    },
  });

  // Step 2: Background image becomes visible
  tl.to('.background-overlay-davinci', { autoAlpha: 1, duration: 0.25 }, '+=0.25');

  // Step 3: Fade out Picasso text, fade in DaVinci text
  tl.to('.picasso-container', { autoAlpha: 0, duration: 1 }, '-=0.5')
    .fromTo('.davinci-container', { autoAlpha: 0 }, { autoAlpha: 1, duration: 1 });

  // Step 4: Control Lottie animation frames on scroll
  tl.to(
    { frame: 0 },
    {
      frame: totalFrames - 1,
      duration: 1.5, // Adjust duration as needed
      onUpdate: function () {
        lottieAnimation.goToAndStop(Math.round(this.targets()[0].frame), true);
      },
      ease: 'none',
    },
    "-=1" // Overlap this animation by 0.5 seconds with the previous one
  );
});

document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-staple');
    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
});


$(document).ready(function() {
    const pageNames = [
      'description',
      'engineering',
      'safety',
      'contribution',
      'model',
      'experiments',
      'results',
      'notebook',
      'parts',
      'human-practices',
      'public-engagement',
      'education',
      'gallery',
      'team',
      'attributions',
      'sponsors',
      'fred-fun'
    ];

    $('#lucky').on('click', function(e) {
        e.preventDefault();

        const randomPage = pageNames[Math.floor(Math.random() * pageNames.length)];

        const pathArray = window.location.pathname.split('/');

        pathArray.pop();

        let newPath = pathArray.join('/');

        newPath = newPath.endsWith('/') ? newPath + randomPage : newPath + '/' + randomPage;

        window.location.href = newPath;
    });
});

gsap.registerPlugin(ScrollTrigger);

const h2Elements = document.querySelectorAll('.animated-text h2');

gsap.set(h2Elements, {
  opacity: 0,
  rotationX: 90,
  transformOrigin: 'center bottom',
});

const fadeInDuration = 1;
const delayBetween = 3;
const fadeOutDuration = 1;
const totalDurationPerHeading = fadeInDuration + delayBetween + fadeOutDuration;

let tl = gsap.timeline({
  scrollTrigger: {
    trigger: '.second-block',
    start: 'center center',
    scrub: 2,
    markers: false, // Disable markers
    pin: true,
  },
});

h2Elements.forEach((h2) => {
  tl.to(h2, {
    opacity: 1,
    rotationX: 0,
    duration: fadeInDuration,
  })
  .to({}, {
    duration: delayBetween,
  })
  .to(h2, {
    opacity: 0,
    rotationX: -90,
    duration: fadeOutDuration,
  });
});
